set CERTFILE=c:\data\certs\sgw_certificate.pem
set CHAINFILE=c:\data\certs\sgw_chain.pem

SET OCSP_RESPONSE=C:\data\certs\good_ocsp_resp.der
SET filesPresent=0
SET ocsp_responder_url=""
SET OCSP_CHECK_LOGFILE=C:\data\logs\ocsp.log
echo ================================================= >> %OCSP_CHECK_LOGFILE%
echo %date% %time% >> %OCSP_CHECK_LOGFILE%

if exist %CERTFILE% ( if exist %CHAINFILE% ( SET filesPresent=1 ) )

IF %filesPresent% == 1 (
  openssl x509 -noout -ocsp_uri -in %CERTFILE% > ocsp_endpoint.txt
  SET /p ocsp_responder_url=< ocsp_endpoint.txt
) ELSE (
  echo "Certificate %CERTFILE% OR %CHAINFILE% is missing. Cannot generate OCSP response." >> %OCSP_CHECK_LOGFILE%
)

IF %ocsp_responder_url% == "" (
  SET ENVOY_CONFIG=C:\program-files\sensor-gateway\config\envoy-config-win.yaml
  echo "No OCSP Responder Found, starting the server in Self Signed Mode.." >> %OCSP_CHECK_LOGFILE%
) ELSE (
  SET ENVOY_CONFIG=C:\program-files\sensor-gateway\config\envoy-config-ocsp-win.yaml
  openssl ocsp -issuer %CHAINFILE% -cert %CERTFILE% -verify_other %CHAINFILE% -CAfile %CHAINFILE% -no_nonce -url %ocsp_responder_url% -respout %OCSP_RESPONSE%
)

echo "Running Command C:\program-files\envoy\envoy.exe --log-path C:\data\logs\envoy-system.log --config-path %ENVOY_CONFIG%" >> %OCSP_CHECK_LOGFILE%
echo ================================================= >> %OCSP_CHECK_LOGFILE%


setx API_ID %API_ID% /M
setx SENSOR_GATEWAY_ENTRY_POINT %SENSOR_GATEWAY_ENTRY_POINT% /M
setx SENSOR_GATEWAY_HOST_IP %SENSOR_GATEWAY_HOST_IP% /M
setx API_KEY %API_KEY% /M
setx CBC_URL %CBC_URL% /M

sc create Envoy binpath= "C:\program-files\envoy\envoy.exe --config-path %ENVOY_CONFIG% --log-path C:\data\logs\envoy-system.log"
sc start Envoy
schtasks /create /tn sensor-gateway-java /tr "cmd /c C:\program-files\sensor-gateway\bin\java_monitor.bat" /sc minute /mo 5 /ru system
schtasks /create /tn sensor-gateway-envoy /tr "cmd /c C:\program-files\sensor-gateway\bin\ocsp_job.bat" /sc daily /st 08:00 /ru system
java -Dlog4j2.formatMsgNoLookups=true -Xms128m -Xmx256m -XX:+UseG1GC -XX:+UseStringDeduplication -Djava.io.tmpdir=C:\\data\\logs -jar C:\\program-files\\sensor-gateway\\lib\\sensor-gateway-mgmt-node-1.0.0.jar
